#!/bin/sh
#
# alias-cid.sh - alias CID|TrueType font to CID-Keyed font
#
# Copyright (C) 2000,2001 Taiji Yamada <taiji@aihara.co.jp>
# All rights reserved.
# This software is provided under the BSD license. For full details,
# please see http://www.freebsd.org/copyright/license.html.
#
# [Acknowledgments]
# It is a pleasure to thank Hideyuki Suzuki <hideyuki@sat.t.u-tokyo.ac.jp>,
# Jerry Zhang <wenlongzhang@redflag-linux.com>,
# Chih-Wei Huang <cwhuang@linux.org.tw>, Yasuhiro Take <take@debian.org>,
# Toshiya Suzuki <mpsuzuki@hiroshima-u.ac.jp> and
# Masatake YAMATO <masata-y@is.aist-nara.ac.jp> for many precious suggestions
# and stimulating discussions about this work.
#
#ResourceDir=.
ResourceDir=`echo "pssystemparams /GenericResourceDir get =" | gsnd -q - `
FontDir=$ResourceDir/Font
CIDFontDir=$ResourceDir/CIDFont
TTFontDir=/usr/local/share/fonts/truetype
# it needs gs_ttf.ps-cjkv-*.patch of http://www.aihara.co.jp/~taiji/tops/
OpenTTFont=.openttcidfont
cid_sh_path=$ResourceDir

case `basename $0` in
######################################################################
# Adobe CNS1
#
'alias-ac13.sh')
ALIASES='
MHei-Medium=MHei-Medium-Acro
MSung-Light=MSung-Light-Acro
DFHeiMedium=dynalab.hk/Dftt_b5d.ttf
DFKaiShuMedium=dynalab.hk/Dftt_k5d.ttf
DFMingLight=dynalab.hk/Dftt_m3d.ttf
MingLiU=office2000/mingliu.ttc
AcademyBIG5=academy/Abig5.ttf
ZenKai-Medium=arphic/bkai00mp.ttf
ShanHeiSun-Light=arphic/bsmi00lp.ttf
Arial-Adobe-CNS1=office2000/arialuni.ttf
'
cid_sh=$cid_sh_path/ac13.sh
;;
######################################################################
# Adobe GB1
#
'alias-ag13.sh')
ALIASES='
MS-Song=fareast/mssong.ttf
MS-Hei=ie_5.01/mshei.ttf
STSong-Light=STSong-Light-Acro
SimSun=office2000/simsun.ttc
NSimSun=office2000/simsun.ttc,2
AcademyGB=academy/Agb.ttf
BousungEG-Light-GB=arphic/gbsn00lp.ttf
GBZenKai-Medium=arphic/gkai00mp.ttf
Arial-Adobe-GB1=office2000/arialuni.ttf
SimKai=MS-Hei
'
cid_sh=$cid_sh_path/ag13.sh
;;
######################################################################
# Adobe Japan1
#
'alias-aj14.sh')
ALIASES='
MS-Gothic=msgothic.ttc
MS-PGothic=msgothic.ttc,2
MS-Mincho=msmincho.ttc
MS-PMincho=msmincho.ttc,2
GothicBBB-Medium=MS-Gothic
Ryumin-Light=MS-Mincho
HeiseiKakuGo-W5=HeiseiKakuGo-W5-Acro
HeiseiMin-W3=HeiseiMin-W3-Acro
HG-GothicB=solaris2.6/ja/HG-GothicB.ttf
HG-MinchoL=solaris2.6/ja/HG-MinchoL.ttf
HGGothicEPRO=hgrgep.ttf
HGSeikaishotaiPRO=hgrskp.ttf
HGMarugothicMPRO=hgrsmp.ttf
DFGothic-EB=dfgoteb.ttc
DFGyoSho-Lt=dfgyomd.ttc
DFMincho-UB=dfminub.ttc
DFMaruMoji-SL=dfmrmmd.ttc
DFPOP1-SB=dfpop.ttc
FA-PopB,Adobe-Japan1-Unicode=pc-9821/FADPOP7.TTF
FA-ReishoM,Adobe-Japan1-Unicode=pc-9821/FADREI5.TTF
FA-Gothic,Adobe-Japan1-Unicode=pc-9821/FANGOT5.TTC
FA-P-Gothic,Adobe-Japan1-Unicode=pc-9821/FANGOT5.TTC,2
FA-FumiyuGothic,Adobe-Japan1-Unicode=pc-9821/FANGOT5.TTC,3
FA-Popol,Adobe-Japan1-Unicode=pc-9821/FANGOT5.TTC,4
FA-GothicB,Adobe-Japan1-Unicode=pc-9821/FANGOT7.TTF
FA-ZuihituGyoshoM,Adobe-Japan1-Unicode=pc-9821/FANGYO5.TTF
FA-KyokashoM,Adobe-Japan1-Unicode=pc-9821/FANKYO5.TTF
FA-Minchou,Adobe-Japan1-Unicode=pc-9821/FANMIN3.TTC
FA-P-Minchou,Adobe-Japan1-Unicode=pc-9821/FANMIN3.TTC,2
FA-FumiyuMinchou,Adobe-Japan1-Unicode=pc-9821/FANMIN3.TTC,3
FA-ClearLetter,Adobe-Japan1-Unicode=pc-9821/FANMIN3.TTC,4
FA-RoundGothicM,Adobe-Japan1-Unicode=pc-9821/FANRGO5.TTF
Arial-Adobe-Japan1=office2000/arialuni.ttf
'
#
#GothicBBB-Medium=WadaGo-Bold
#Ryumin-Light=WadaMin-Regular
#
#GothicMB101-Bold=WadaMaruGo-Regular
#HeiseiKakuGo-W5=WadaGo-Bold
#HeiseiMin-W3=WadaMin-Regular
#MidashiGo-MB31=WadaGo-Bold
#MidashiMin-MA31=WadaMin-Bold
#Ryumin-Bold=WadaMin-Bold
#ShinGo-Bold=WadaMin-Bold
#ShinGo-Medium=WadaMaruGo-Regular
#ShinGo-regular=WadaMin-Regular
cid_sh=$cid_sh_path/aj14.sh
;;
######################################################################
# Adobe Japan2
#
'alias-aj20.sh')
ALIASES='
MS-Gothic-Adobe-Japan2=msgothic.ttc
MS-PGothic-Adobe-Japan2=msgothic.ttc,2
MS-Mincho-Adobe-Japan2=msmincho.ttc
MS-PMincho-Adobe-Japan2=msmincho.ttc,2
HG-GothicB-Adobe-Japan2=solaris2.6/ja/HG-GothicB.ttf
HG-MinchoL-Adobe-Japan2=solaris2.6/ja/HG-MinchoL.ttf
Arial-Adobe-Japan2=office2000/arialuni.ttf
'
cid_sh=$cid_sh_path/aj20.sh
;;
######################################################################
# Adobe Korea1
#
'alias-ak12.sh')
ALIASES='
HYGoThic-Medium=HYGoThic-Medium-Acro
HYSMyeongJo-Medium=HYSMyeongJo-Medium-Acro
Batang=office2000/batang.ttc
BatangChe=office2000/batang.ttc,2
Gungsuh=office2000/batang.ttc,3
GungsuhChe=office2000/batang.ttc,4
GulimChe=ie_5.01/GulimChe.ttf
Arial-Adobe-Korea1=office2000/arialuni.ttf
'
#Batang=fareast/batang.ttf
cid_sh=$cid_sh_path/ak12.sh
;;
#
# print usage
#
*)
if [ "$1" != 'uninstall' ]; then
  cat <<EOF
do not execute $0, directly! in the case except for uninstall
usage: alias-(ac13|ag13|aj14|aj20|ak12).sh 'install|uninstall' [Alias=Font...]
EOF
  exit
fi
;;
esac

case $1 in
'install')
  if [ "$2" != '' ]; then
    shift
    ALIASES=$*
  fi
  for alias in $ALIASES; do
    FNN=`echo $alias|/bin/sed -n -e 's/^\(.*\)=\(.*\)$/\1/p'`
    fnn=`echo $alias|/bin/sed -n -e 's/^\(.*\)=\(.*\)$/\2/p'`
    [ "$FNN" = '' -o "$fnn" = '' ] && echo "error: $alias" && exit 1
    TTE=''
    case $FNN in
    *-Adobe-*[0-9])
      TTE=' /'`echo $FNN|/bin/sed -n -e 's/^.*-\(Adobe-.*[0-9]\)$/\1/p'`'-Unicode'
      ;;
    *,Adobe-*[0-9]-*)
      TTE=' /'`echo $FNN|/bin/sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\2/p'`
      FNN=`echo $FNN|/bin/sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\1/p'`
      ;;
    esac
    case $fnn in
    *.ttc,[0-9]|*.TTC,[0-9])
      TTF=`echo $fnn|/bin/sed -n -e 's/^\(.*\),\([0-9]\)$/\1/p'`
      TTI=`echo $fnn|/bin/sed -n -e 's/^\(.*\),\([0-9]\)$/\2/p'`
      if [ ! -f $TTFontDir/$TTF ]; then
        echo "$TTF not found in $TTFontDir"; continue
      fi
      [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$TTF"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
($TTFontDir/$TTF) $TTI$TTE $OpenTTFont
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      ;;
    *.tt[fc]|*.TT[FC])
      TTF=$fnn
      if [ ! -f $TTFontDir/$TTF ]; then
        echo "$TTF not found in $TTFontDir"; continue
      fi
      [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$TTF"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
($TTFontDir/$TTF)$TTE $OpenTTFont
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      ;;
    *)
      if [ ! -f $CIDFontDir/$fnn ]; then
        echo "$fnn not found in $CIDFontDir"; continue
      fi
      [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$fnn"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
/$fnn /CIDFont findresource
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      ;;
    esac
    [ "$cid_sh" != '' ] && (cd $ResourceDir; $cid_sh install $FNN)
  done
  ;;
'uninstall')
  if [ "$2" != '' ]; then
    shift
    ALIASES=$*
  fi
  for alias in $ALIASES; do
    FNN=`echo $alias|/bin/sed -n -e 's/^\(.*\)=\(.*\)$/\1/p'`
    fnn=`echo $alias|/bin/sed -n -e 's/^\(.*\)=\(.*\)$/\2/p'`
    case $FNN in
    *,Adobe-*[0-9]-*)
      FNN=`echo $FNN|/bin/sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\1/p'`
      ;;
    '')
      FNN=$alias
      ;;
    esac
    [ "$cid_sh" != '' ] && (cd $ResourceDir; $cid_sh uninstall $FNN)
    [ "$cid_sh" = '' ] && (cd $ResourceDir; $cid_sh_path/cid.sh uninstall $FNN)
    [ -f $CIDFontDir/$FNN ] && rm -f $CIDFontDir/$FNN && echo "-$FNN"
  done
  ;;
*)
  cat <<EOF
usage: $0 'install|uninstall' [Arias=Font...]
please edit the lines ALIASES=<alias>=<name>... of me, before use without args.
EOF
  ;;
esac
